include "Zeropage.inc"
include "VVram.inc"

ext VVram_
ext Map_
ext BaseX_, BaseY_
ext PollVSync_

Char_Space equ $20
Char_Wall equ $66
MapStep equ 8

pSource equ ZW0
pDestination equ ZW1

; ptr<byte> VVramPtr(byte x, byte y);
dseg
VVramPtr_@Param0: public	VVramPtr_@Param0
VVramPtr_.x_:	defs 1
VVramPtr_@Param1: public	VVramPtr_@Param1
VVramPtr_.y_:	defs 1
cseg
VVramPtr_: public	VVramPtr_
	pha
        lda	VVramPtr_.y_
        asl a ;*2
        asl a ;*4
        asl a ;*8
        sta <pDestination | lda #0 | sta <pDestination+1
        asl <pDestination | rol <pDestination+1 ;16
        asl <pDestination | rol <pDestination+1 ;32
        lda VVramPtr_.x_ | clc | adc <pDestination | sta <pDestination
        lda <pDestination+1 | adc #0 | sta <pDestination+1
        lda <pDestination | clc|adc #low VVram_ | tay
        lda <pDestination+1 | adc #high VVram_ | tax
	pla
rts


; void MapToVVram();
zseg
mapOffset:
    defb 0
vvramOffset:
    defb 0
mapByte:
    defb 0
cseg
MapToVVram_: public MapToVVram_
    pha
        lda BaseY_ | sta <pSource+0
        lda #0 | sta <pSource+1
        asl <pSource+0 | rol <pSource+1   ; *2
        asl <pSource+0 | rol <pSource+1   ; *4
        asl <pSource+0 | rol <pSource+1   ; *8 : MapStep
        
        lda <pSource+0 | clc|adc #low Map_ | sta <pSource+0
        lda <pSource+1 | adc #high Map_ | sta <pSource+1

        lda BaseX_
        lsr a | lsr a | lsr a
        clc|adc <pSource+0 | sta <pSource+0
        lda <pSource+1 | adc #0 | sta <pSource+1
        
        lda #1 | sta <mapByte
        lda BaseX_
        and #7
        tax
        do | while ne
            asl <mapByte
            dex
        wend
        ldy #0 | sty <mapOffset

        lda #low VVram_ | sta <pDestination+0
        lda #high VVram_ | sta <pDestination+1

        ldx #VVramHeight
        do
            ldy #0
            do
                sty <vvramOffset

                ldy <mapOffset
                lda (<pSource),y
                and <mapByte
                if ne
                    lda #Char_Wall
                else
                    lda #Char_Space
                endif
                
                asl <mapByte
                if eq
                    iny
                    inc <mapByte
                endif
                sty <mapOffset

                ldy <vvramOffset
                sta (<pDestination),y
                iny
                cpy #VVramWidth
            while ne | wend
            lda <mapOffset
            clc|adc #MapStep-VVramWidth/8
            sta <mapOffset
            
            lda <pDestination+0 | clc|adc #VVramWidth | sta <pDestination+0
            lda <pDestination+1 | adc #0 | sta <pDestination+1

            dex
        while ne | wend
    pla
rts
